
;; -*- emacs-lisp -*-

;; Additions to C-mode for recent emacsen (19.30 onwards) to highlight
;; bsp functions as keywords, and bsp_sync specially (by default, in
;; inverse boldface italics---I had a mono screen at the time).  Also
;; redefines forward and backward page (not usually useful in C-mode)
;; to move between supersteps.
;;
;; You'll want to switch font-lock mode on in your .emacs; I do
;; (global-font-lock-mode 1) but there are other ways of doing it.
;;
;; I suggest you call this bsp-utils.el, byte compile it (and
;; font-lock-add.el) and do a (require 'bsp-utils) in your .emacs
;;
;; (I use (setq font-lock-maximum-decoration t), but that's a matter
;; of taste.)  Many thanks to Simon Marshall for font-lock-add.el
;;
;; Bruce Stephens <B.Stephens@math.ruu.nl>

(provide 'bsp-utils)
(require 'font-lock-add)

(font-lock-make-face '(font-lock-type-face nil nil t t nil))
(font-lock-make-face '(font-lock-bsp-sync-face "white" "black" t t nil))

(defvar bsp-sync-regexp "\\<bsp_sync\\s-*(\\s-*)"
  "Regexp that matches a bsp synchronize")

(font-lock-add-keywords
 'c-mode
 (list (list bsp-sync-regexp 0 'font-lock-bsp-sync-face)
       '("\\<bsp_[a-z]+\\>" 0 font-lock-keyword-face)))

(font-lock-add-keywords
 'c++-mode
 (list (list bsp-sync-regexp 0 'font-lock-bsp-sync-face)
       '("\\<bsp_[a-z]+\\>" 0 font-lock-keyword-face)))

(defun bsp-change-page-delimiter ()
  (setq page-delimiter
	(concat page-delimiter
		"\\|"
		bsp-sync-regexp)))

(make-variable-buffer-local 'page-delimiter)

(add-hook 'c-mode-common-hook 'bsp-change-page-delimiter)

