/*   Author: Rob Bisseling.  Last modified: 15-8-1996.  Copyright reserved.*/

#include "bsplu.h"


double *vecallocd(int n){
    /* This allocates a vector of doubles of length n */
    double *pd;
    pd= (double *)calloc(n,sizeof(double));
    if (pd==NULL)
	bsp_abort("vecallocd: not enough memory");
    return pd;
}

int *vecalloci(int n){
    /* This allocates a vector of integers of length n */
    int *pi;
    pi= (int *)calloc(n,sizeof(int));
    if (pi==NULL)
	bsp_abort("vecalloci: not enough memory");
    return pi;
}

double **matallocd(int m, int n){
    /* This allocates an m x n matrix of doubles */
    int i;
    double **ppd;
    ppd= (double **)calloc(m,sizeof(double *));
    if (ppd==NULL)
	bsp_abort("matallocd: not enough memory");
    for (i=0; i<m; i++){
        ppd[i]= (double *)calloc(n,sizeof(double)); 
        if (ppd[i]==NULL)
	    bsp_abort("matallocd: not enough memory");
    }
    return ppd;
}
