/********************************************************************/
/* Copyright (c) 1995 Mark W. Goudreau, Kevin Lang, Satish B. Rao,  */
/*                    Torsten Suel and Thanasis Tsantilas.          */
/*                                                                  */
/* All rights reserved.                                             */
/*                                                                  */
/* Permission is given to use, copy, and modify this software for   */
/* any non-commercial purpose as long as this copyright notice is   */
/* not removed.  All other uses, including redistribution in whole  */
/* or in part, are forbidden without prior written permission.      */
/*                                                                  */
/********************************************************************/

/********************************************************************/
/*                                                                  */
/* Green BSP Library                                                */
/* Matrix generation program.                                       */
/*                                                                  */
/* To generate M random matrices of size NxN, use:                  */
/*                                                                  */
/*    % genmatrix M N                                               */
/*                                                                  */
/********************************************************************/

/*** SCCS LABEL ***/
static char SccsId[] = "@(#)genMatrix.c	1.1 (Green BSP Library) 10/2/95";

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "prandom.h"

#define SCALE 0.4656612875e-9  
#define myrandom(x)  ((x) * (prandom() * SCALE ))

#define dotimes(var,lim) for (var=0;var<(lim);var++) 

void main(int argc, char *argv[])
{
  int seed = time(NULL);
  int nmat, matwid;
  int i, j, k;
  
  if (argc < 2) {
    fprintf(stderr, "Usage: %s n-matrices matwid.\n", argv[0]);
    exit(0);
  }
  nmat = atoi (argv[1]);
  matwid = atoi (argv[2]);

  psrandom(seed);

  printf("%d\n", matwid);
  dotimes (i, nmat)
    dotimes (j, matwid)
      dotimes (k, matwid)
	printf("%6.4f\n", myrandom(10.0) - 5.0);
}
