/********************************************************************/
/* Copyright (c) 1995 Mark W. Goudreau, Kevin Lang, Satish B. Rao,  */
/*                    Torsten Suel, and Thanasis Tsantilas.         */
/*                                                                  */
/* All rights reserved.                                             */
/*                                                                  */
/* Permission is given to use, copy, and modify this software for   */
/* any non-commercial purpose as long as this copyright notice is   */
/* not removed.  All other uses, including redistribution in whole  */
/* or in part, are forbidden without prior written permission.      */
/*                                                                  */
/********************************************************************/

/********************************************************************/
/*                                                                  */
/* Green BSP Library                                                */
/* Matrix multiply function call.                                   */ 
/*                                                                  */
/********************************************************************/

/*** SCCS Identification ***/
static char SccsId[] = "@(#)libmatrix.c	1.1 (Green BSP Library) 10/2/95";

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <time.h>
#include <assert.h>

#define ROWM(row, column, nColumns) (row) * (nColumns) + (column)
#define COLM(row, column, nRows) (column) * (nRows) + (row)

extern int millisecond_timer ();


/* A is row-major, B is column-major */
double *matrixMultiply(const double *A, const double *B,
                    int RowsA, int ColsA, int ColsB)
{
   int row, col, i;
   double value;
   double *C;



   C = calloc(RowsA * ColsB, sizeof(double));
   assert(C != NULL);

   for(row = 0; row < RowsA; row++)
      for(col = 0; col < ColsB; col++)
      {
         value = 0.0;
         for(i = 0; i < ColsA; i++)
            value += A[ROWM(row, i, ColsA)]
                   * B[COLM(i, col, ColsA)];
         C[ROWM(row, col, ColsB)] = value;
      }

   return(C);
}
