
/* matmult.h */

/* #define BLOCKSIZE 96  */       /* sidelength of block */
#define BLOCKSIZE 23         /* sidelength of block */
#define VERBOSE 0            /* output timings for all parts of program */
#define INFILE "matrix.dat"
#define OUTFILE "out.dat"

/******************************************************/
/* Data structure to hold all globally used variables */
/******************************************************/

typedef struct {
  int numProcs;        /* number of processors */
  int rootProcs;       /* sqrt of number of processors */
  int myProc;          /* index of this processor */
  int matSize;         /* side length of the matrices */
  int locMatSize;      /* size of local part of matrix */
  int locMatSizeSq;    /* square of size of local part of matrix */
  int locFirstRow;     /* number of first row of local part of matrix */
  int locFirstCol;     /* number of first column of local part of matrix */
  double *matA;        /* local part of matrix A */
  double *matB;        /* local part of matrix B */
  double *matC;        /* local part of result matrix C = AxB */
} globals;

void getInput(globals *);
void sendMat(double *, int, globals *);
void seqMatMult(double *, double *, double *, globals *);
void finalOutput(globals *);
