/********************************************************************/
/* Copyright (c) 1995 Mark W. Goudreau, Kevin Lang, Satish B. Rao,  */
/*                    Torsten Suel and Thanasis Tsantilas.          */
/*                                                                  */
/* All rights reserved.                                             */
/*                                                                  */
/* Permission is given to use, copy, and modify this software for   */
/* any non-commercial purpose as long as this copyright notice is   */
/* not removed.  All other uses, including redistribution in whole  */
/* or in part, are forbidden without prior written permission.      */
/*                                                                  */
/********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#define ROWM(row, column, nColumns) (row) * (nColumns) + (column)
#define COLM(row, column, nRows) (column) * (nRows) + (row)

int main(int argc, char *argv[])
{
   FILE *dataFile;

   double *a, *b, *c;
   double value;

   int MATSize;
   int row, column;
   int k;
   int prnt;

   double *matrixMultiply(const double *A, const double *B,
                          int RowsA, int ColsA, int ColsB);


   prnt = 1;
   if(argc > 1)
   {
      if(strcmp(argv[1], "-P") == 0)
      {
         prnt = 0;
      }
      else
      {
         printf("Illegal input options.  Terminate.\n");
         exit(0);
      }
   }


   /* read in data from file "matrix.dat" */
   if((dataFile = fopen("matrix.dat", "r")) == NULL)
   {
      printf("File could not be opened.  Terminate.\n");
      exit(0);
   }

   /* read in MATSize */
   fscanf(dataFile, "%d", &MATSize);

   /* allocate memory for the arrays */
   k = MATSize * MATSize;
   a = calloc(k, sizeof(double));
   b = calloc(k, sizeof(double));

   /* read in the arrays a[][] and b[][] */

   /* read in a[][] */
   for(row = 0; row < MATSize; row++)
      for(column = 0; column < MATSize; column++)
         fscanf(dataFile, "%lg", &a[ROWM(row, column, MATSize)]);

   /* read in b[][] */
   for(row = 0; row < MATSize; row++)
      for(column = 0; column < MATSize; column++)
         fscanf(dataFile, "%lg", &b[COLM(row, column, MATSize)]);

   fclose(dataFile);

   c = matrixMultiply(a, b, MATSize, MATSize, MATSize);


   if(prnt == 1)
   {
      dataFile = fopen("outSeq.dat", "w");

      for(row = 0; row < MATSize; row++)
         for(column = 0; column < MATSize; column++)
            fprintf(dataFile, "%g\n", c[ROWM(row, column, MATSize)]);

      fclose(dataFile);
   }

   return 0;
}
